cordova.define("uc-cordova-plugin-privacyscreen.PrivacyScreenPlugin", function(require, exports, module) {
function PrivacyScreen() {}

//Default time to remove privacy screen is 2 seconds (+0.1s for fade animation)
PrivacyScreen.prototype.setTimer = function(successCallback, errorCallback, timeInterval) {
    cordova.exec(successCallback, errorCallback, "PrivacyScreenPlugin", "setTimer", [timeInterval]);
};

PrivacyScreen.prototype.hidePrivacyScreen = function(successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, "PrivacyScreenPlugin", "hidePrivacyScreen", []);
};

PrivacyScreen.prototype.showPrivacyScreen = function(successCallback, errorCallback) {
    cordova.exec(successCallback, errorCallback, "PrivacyScreenPlugin", "showPrivacyScreen", []);
};

PrivacyScreen.prototype.enabled = function(enabled) {
  cordova.exec(null, null, "PrivacyScreenPlugin", "enabled", [enabled]);
};



PrivacyScreen.install = function() {
    if (!window.plugins) {
        window.plugins = {};
    }

    window.plugins.privacyscreen = new PrivacyScreen();
    return window.plugins.privacyscreen;
};

module.exports = PrivacyScreen;

cordova.addConstructor(PrivacyScreen.install); 
});
